#pragma once

#include "CoreMinimal.h"
#include "Presenter.h"
#include "Templates/SubclassOf.h"
#include "EPlayerRole.h"
#include "ArchivesPresenter.generated.h"

class UUserWidget;
class UArchiveTomeSubPresenter;
class UArchiveCompendiumSubPresenter;
class USubPresenter;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIPRESENTERS_API UArchivesPresenter : public UPresenter
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<UUserWidget> ArchivesWidgetClass;

private:
	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UArchiveTomeSubPresenter* _archiveTomeSubPresenter;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UArchiveCompendiumSubPresenter* _archiveCompendiumSubPresenter;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	USubPresenter* _activeSubPresenter;

private:
	UFUNCTION(BlueprintCallable)
	void OnSlotSelectorClosed();

	UFUNCTION(BlueprintCallable)
	void OnShowImageViewer(bool voiceOverIsPlaying);

	UFUNCTION(BlueprintCallable)
	void OnSettingsButtonClicked();

	UFUNCTION(BlueprintCallable)
	void OnInfoButtonClicked();

	UFUNCTION(BlueprintCallable)
	void OnHideImageViewer();

	UFUNCTION(BlueprintCallable)
	void OnChallengeReminderSlotSelected(EPlayerRole role);

	UFUNCTION(BlueprintCallable)
	void OnChallengeReminderClicked(EPlayerRole role);

	UFUNCTION(BlueprintCallable)
	void OnBackButtonClicked();

public:
	UArchivesPresenter();
};

FORCEINLINE uint32 GetTypeHash(const UArchivesPresenter) { return 0; }
